#!/usr/bin/env python3
# NeoPixel Library standard test routines
# Author: Tony DiCola
# Description：Display various fancy controls in the light strip
#

import time
from rpi_ws281x import PixelStrip, Color
import argparse

# LED Light strip configuration:
LED_COUNT = 30        # Number of LEDs
LED_PIN = 18          # GPIO18 (18 USE PWM).
LED_FREQ_HZ = 800000  # LED signal frequency (Hz) (usually 800khz)
LED_DMA = 10          # Direct memory access channels are used to generate signals (attempt 10)
LED_BRIGHTNESS = 255  # 0: the darkest, 255: the brightest.
LED_INVERT = False    # if True：Signal inversion (when using NPN transistor level shift)
LED_CHANNEL = 0       #  if 1 ：needs GPIOs 13, 19, 41, 45 or 53


#Define the LED action function.

def colorWipe(strip, color, wait_ms=50):
    """LED lamp beads light up one by one"""
    for i in range(strip.numPixels()):
        strip.setPixelColor(i, color)
        strip.show()
        time.sleep(wait_ms / 1000.0)


def theaterChase(strip, color, wait_ms=50, iterations=10):
    """Cinema lighting style"""
    for j in range(iterations):
        for q in range(3):
            for i in range(0, strip.numPixels(), 3):
                strip.setPixelColor(i + q, color)
            strip.show()
            time.sleep(wait_ms / 1000.0)
            for i in range(0, strip.numPixels(), 3):
                strip.setPixelColor(i + q, 0)


def wheel(pos):
    """Generate rainbow colors spanning 0-255 positions."""
    if pos < 85:
        return Color(pos * 3, 255 - pos * 3, 0)
    elif pos < 170:
        pos -= 85
        return Color(255 - pos * 3, 0, pos * 3)
    else:
        pos -= 170
        return Color(0, pos * 3, 255 - pos * 3)


def rainbow(strip, wait_ms=20, iterations=1):
    """Draw a rainbow, fade out all pixels at once."""
    for j in range(256 * iterations):
        for i in range(strip.numPixels()):
            strip.setPixelColor(i, wheel((i + j) & 255))
        strip.show()
        time.sleep(wait_ms / 1000.0)


def rainbowCycle(strip, wait_ms=20, iterations=5):
    """Draw a rainbow evenly distributed across all pixels."""
    for j in range(256 * iterations):
        for i in range(strip.numPixels()):
            strip.setPixelColor(i, wheel(
                (int(i * 256 / strip.numPixels()) + j) & 255))
        strip.show()
        time.sleep(wait_ms / 1000.0)


def theaterChaseRainbow(strip, wait_ms=50):
    """Rainbow Cinema Lighting Style."""
    for j in range(256):
        for q in range(3):
            for i in range(0, strip.numPixels(), 3):
                strip.setPixelColor(i + q, wheel((i + j) % 255))
            strip.show()
            time.sleep(wait_ms / 1000.0)
            for i in range(0, strip.numPixels(), 3):
                strip.setPixelColor(i + q, 0)


# Main function:
if __name__ == '__main__':

    #Terminal execution parameters
    parser = argparse.ArgumentParser()
    parser.add_argument('-c', '--clear', action='store_true', help='clear the display on exit')
    args = parser.parse_args()

    # Construct the light strip object according to the parameters.
    strip = PixelStrip(LED_COUNT, LED_PIN, LED_FREQ_HZ, LED_DMA, LED_INVERT, LED_BRIGHTNESS, LED_CHANNEL)

    # Light strip initialization
    strip.begin()

    print('Press Ctrl-C to quit.')
    if not args.clear:
        print('Use "-c" argument to clear LEDs on exit')

    try:

        while True:
            #Light up one by one
            print('Color wipe animations.')
            colorWipe(strip, Color(255, 0, 0))  # RED
            colorWipe(strip, Color(0, 255, 0))  # GREEN
            colorWipe(strip, Color(0, 0, 255))  # BLUE

            #Cinema mode
            print('Theater chase animations.')
            theaterChase(strip, Color(127, 127, 127))  # White theater chase
            theaterChase(strip, Color(127, 0, 0))  # Red theater chase
            theaterChase(strip, Color(0, 0, 127))  # Blue theater chase

            #Rainbow Mode
            print('Rainbow animations.')
            rainbow(strip)
            rainbowCycle(strip)
            theaterChaseRainbow(strip)

    #Command interruption: Ctrl+C
    except KeyboardInterrupt:
        if args.clear:
            colorWipe(strip, Color(0, 0, 0), 10)
